"use strict";

const invoke = require("../interface/invoke");
const query = require("../interface/query");

exports.recordFunction = async function(
  user,
  functionId,
  functionName,
  applicationId,
  bundleURL,
  bundleHash,
  functionEncoded,
  functionStatus
) {
  try {
    const payload = {
      functionId,
      functionName,
      applicationId,
      bundleURL,
      bundleHash,
      functionEncoded,
      functionStatus
    };
    await invoke(user, "recordFunction", payload);
    return "transaction submitted";
  } catch (err) {
    return err;
  }
};

exports.updateFunction = async function(
  user,
  functionId,
  functionName,
  applicationId,
  bundleURL,
  bundleHash,
  functionEncoded,
  functionStatus
) {
  try {
    const payload = {
      functionId,
      functionName,
      applicationId,
      bundleURL,
      bundleHash,
      functionEncoded,
      functionStatus
    };
    await invoke(user, "updateFunction", payload);
    return "transaction submitted";
  } catch (err) {
    return err;
  }
};

exports.queryFunction = async function(user, functionId) {
  try {
    const queryJSON = {
      functionId
    };
    return await query(user, "queryFunction", queryJSON);
  } catch (err) {
    return err;
  }
};

exports.queryFunctionHistory = async function() {
  // stub
};

exports.queryFunctionList = async function(user) {
  try {
    return await query(user, "queryFunctionList");
  } catch (err) {
    return err;
  }
};

exports.deleteFunction = async function(user, functionId) {
  try {
    const payload = {
      functionId
    };
    await invoke(user, "deleteFunction", payload);
    return "transaction submitted";
  } catch (err) {
    return err;
  }
};
